/**
 * @file  sci.h
 * @brief SCIhCowb_
 *
 * {\tgEFA̒쌠͍쐬ł()kldqL̂ƂA
 * ()kldq́Aȉ (1)`(3) ̏𖞂ꍇɌA
 * {\tgEFAi{\tgEFAς̂܂ށBȉj
 * gpEEρEĔzziȉApƌĂԁj邱Ƃ𖳏ŋB
 *
 * (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́AL̒
 *	   \A̗pÂ܂܂̌`Ń\[XR[hɊ܂܂
 *	   邱ƁB
 * (2) {\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ֎~
 *	   ƂBGȂǂ֏ЉE^̏ꍇ()kldqɘA肢܂B
 * (3) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *	   A()kldq͈؂̐ӔC𕉂Ȃ̂ƂB
 *
 * Copyright (C) Hokuto denshi Co,Ltd. 2021
 */

#ifndef __SCI_H__
#define __SCI_H__

/*----------------------------------------------------------------------
	CN[h
----------------------------------------------------------------------*/

#include "ada_if_userdef.h"

/*----------------------------------------------------------------------
	^`
----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
	萔`
----------------------------------------------------------------------*/
#if (USE_SCI == 1)
#define SCI_BUF_SIZE	2048
#else
#define SCI_BUF_SIZE	1
#endif

#define SCR		SCI1.SCR
#define SMR		SCI1.SMR
#define SCMR	SCI1.SCMR
#define BRR		SCI1.BRR
#define TDR		SCI1.TDR
#define RDR		SCI1.RDR
#define SSR		SCI1.SSR
#define SEMR	SCI1.SEMR

/*----------------------------------------------------------------------
	OQƁi֐j
----------------------------------------------------------------------*/
extern void sci_init( void );
extern char sci_read_char( void );
extern void sci_write_char( unsigned char c );
extern void sci_write_flush(void);
extern void sci_write_str( char *str );
extern void sci_write_uint8_hex( unsigned char n );
extern void sci_wite_uint16_hex( unsigned short n );
extern void sci_write_uint32_hex( unsigned long n );
extern void sci_write_uint8( unsigned char n );
extern void sci_write_uint16( unsigned short n );
extern void sci_write_uint32( unsigned long n );
extern void sci_write_int8( char n );
extern void sci_write_int16( short n );
extern void sci_write_int32( long n );


/*----------------------------------------------------------------------
	OQƁiϐj
----------------------------------------------------------------------*/
extern unsigned char g_sci_tx_buf[];
extern unsigned short g_sci_tx_buf_wp, g_sci_tx_buf_rp;

extern char g_sci_rx_buf;

extern unsigned long g_sci_rx_flag;
extern unsigned long g_sci_tx_wait_flag;

#endif
/* End of File */
