
#ifndef __ADA_IF_H__
#define __ADA_IF_H__


#include "r_cg_macrodriver.h"
#include "ada_if_userdef.h"

//`l

#define FS (48000)						//TvOg(48kHz)


#if (USE_CH == 1)

typedef struct{
  float ch0;
} PCM_float;

#if (DATA_BUFFER_SIZE_SAME == 1)

#define DATA_BUFFER_SIZE 	(114688)			//448kB, ̓obt@Əo̓obt@̃TCY𓯂Ƃ
#define INPUT_BUFFER_SIZE	DATA_BUFFER_SIZE
#define OUTPUT_BUFFER_SIZE	DATA_BUFFER_SIZE

#else

#define INPUT_BUFFER_SIZE	(131072)			//512kB
#define OUTPUT_BUFFER_SIZE	(114688)			//448kB

#endif

#elif (USE_CH == 2)

typedef struct{
  float ch0;
  float ch1;
} PCM_float;

#if (DATA_BUFFER_SIZE_SAME == 1)

#define DATA_BUFFER_SIZE 	(57344)				//448kB, ̓obt@Əo̓obt@̃TCY𓯂Ƃ
#define INPUT_BUFFER_SIZE	DATA_BUFFER_SIZE
#define OUTPUT_BUFFER_SIZE	DATA_BUFFER_SIZE

#else

#define INPUT_BUFFER_SIZE	(65536)				//512kB
#define OUTPUT_BUFFER_SIZE	(57344)				//448kB

#endif

#endif

//O[oϐ
extern PCM_float g_pcm0[];		//input
extern PCM_float g_pcm1[];		//output

extern volatile int g_input_index;
extern volatile int g_output_index;

extern PCM_float g_zero_data;

extern unsigned long g_sw_state;

extern unsigned short g_ad_flag;
extern unsigned short g_ad_val[];

extern unsigned long g_led_pattern;
extern unsigned long g_led_pattern_index;


//֐vg^Cv

extern void ada_if_init( void );
extern int ada_if_start( void );
extern int ada_if_input_index(int n);
extern int ada_if_output_index(int n);
extern int ada_if_input_index_diff(int n, int m);
extern int ada_if_output_index_diff(int n, int m);

#endif
