
#include "sound_effect.h"
#include <mathf.h>

void reverb(int offset, int data_handling_size)
{
	int n;
	short volume1 = g_ad_val[0], volume2 = g_ad_val[1], volume3 = g_ad_val[2];
	int m, d, i;
	float s, a;

	d = (int)((float)FS * 0.1 * (float)volume1 / 4096.0);
	a = (float)volume2 / 4096.0;

	for (n = 0; n < data_handling_size; n++)
	{
		s = g_pcm0[offset + n].ch0;
		
		for (i = 1; i <= 10; i++)
		{
			m = offset + n - d * i;
		if (m < 0)
		{
			m += DATA_BUFFER_SIZE;
		}

		s += g_pcm0[m].ch0 * powf(a, (float)i);
	}

	g_pcm1[offset + n].ch0 = s;
	
	}
}
